'use strict';

exports.__esModule = true;
exports.default = createInsertFactory;
function createInsertFactory(t, jsxPragma) {
    var jsxId = t.identifier(jsxPragma);
    // const stateId = t.identifier('state')
    function getDeclaration() {
        var th = arguments.length <= 0 || arguments[0] === undefined ? t.thisExpression() : arguments[0];

        return t.variableDeclaration('const', [t.variableDeclarator(jsxId, t.memberExpression(th, jsxId))]);
    }
    var fallbackDeclaration = getDeclaration();
    var objPropertyId = t.objectProperty(jsxId, jsxId);

    var paramIndex = 0;

    return function insertFactory(node) {
        if (node.params && node.params[paramIndex]) {
            var param = node.params[paramIndex];
            switch (param.type) {
                case 'ObjectPattern':
                    param.properties.push(objPropertyId);
                    return;
                case 'Identifier':
                    node.body.body.unshift(getDeclaration(param));
                    return;
                default:
                    break;
            }
        }
        if (node.type === 'ClassMethod') {
            node.body.body.unshift(fallbackDeclaration);
        }
    };
}
//# sourceMappingURL=createInsertFactory.js.map