'use strict';

exports.__esModule = true;
exports.default = createInjectParamTypes;
function createInjectParamTypes(t, reflectId, typeForAnnotations, paramKey, typeKey) {
    var metaDataId = t.memberExpression(reflectId || t.identifier('Reflect'), t.identifier('defineMetadata'));

    return function defineMetadata(types, target, type) {
        var body = [];
        if (types.length) {
            var typeArgs = typeForAnnotations(types);
            if (typeArgs.length) {
                body.push(t.expressionStatement(t.callExpression(metaDataId, [t.stringLiteral(paramKey), t.arrayExpression(typeArgs), target])));
            }

            for (var i = 0; i < types.length; i++) {
                var argType = types[i];
                var decorators = argType.decorators || [];
                for (var j = 0; j < decorators.length; j++) {
                    body.push(t.expressionStatement(t.callExpression(decorators[j].expression, [target, t.identifier('null'), t.identifier(i.toString())])));
                }
            }
        }

        if (type === 'FunctionDeclaration') {
            body.push(t.expressionStatement(t.callExpression(metaDataId, [t.stringLiteral(typeKey), t.booleanLiteral(true), target])));
        }

        return body;
    };
}
//# sourceMappingURL=createInjectParamTypes.js.map